﻿//-------------------------------------
// WBFSSync - WBFSSync.exe
//
// Copyright 2009 Caian (ÔmΣga Frøst) <frost.omega@hotmail.com>
//
// WBFSSync is Licensed under the terms of the Microsoft Reciprocal License (Ms-RL)
//
// Operation.cs:
//
// Classe que descreve uma Operação realizada pelo WBFSSync
//
//-------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace WBFSSync
{
    public class Operation
    {
        ushort uid = 0;
        public ushort UniqueID { get { return uid; } }

        public OperationType Type = OperationType.Unknown;

        public ProgressIndicator Progress = new ProgressIndicator();
        public Boolean Waiting = true;
        public Boolean InUse = false;

        public Boolean IsSourceWBFS { get { return SourceDrive == null ? false : SourceDrive.Is(DriveFlags.WBFS); } }
        public Boolean IsDestinationWBFS { get { return DestinationDrive == null ? false : DestinationDrive.Is(DriveFlags.WBFS); } }

        public String SourcePath = "";
        public String DestinationPath = "";

        public IDrive SourceDrive = null;
        public IDrive DestinationDrive = null;

        public Int64 DestinationSize = 0;
        public Int64 DestinationReserved = 0;

        public Object ExtendedInfo = null;

        public Operation(ushort _uid)
        {
            uid = _uid;
        }

        // 2.0
    }
}
