﻿//-------------------------------------
// WBFSSync - WBFSSync.exe
//
// Copyright 2009 Caian (ÔmΣga Frøst) <frost.omega@hotmail.com> :
//
// WBFSSync is Licensed under the terms of the Microsoft Reciprocal License (Ms-RL)
//
// TagMetadata.cs:
//
// Estrutura que descreve um item do Explorer
//
//-------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WBFSSync
{
    [Flags]
    public enum SelectionType : byte
    {
        Invalid = 0,
        Folder = 1,
        File = 2,
        Rar = 4,
        Iso = 8,
        Disc = 16,
        Drive = 32,

        Library = 64,
        Covers = 128,
    }

    public struct TagMetadata
    {
        public String Path;
        public SelectionType Type;
        public Object Meta1;
        public Object Meta2;

        public TagMetadata(string p, SelectionType t, object m1)
        {
            Path = p;
            Type = t;
            Meta1 = m1;
            Meta2 = null;
        }

        public TagMetadata(string p, SelectionType t, object m1, object m2)
        {
            Path = p;
            Type = t;
            Meta1 = m1;
            Meta2 = m2;
        }
    }
}
