﻿//-----------------------------------------------------------------------------------------------------------
// WBFSSync Project by Omega Frost 
// http://wbfssync.codeplex.com/
//
// WBFSSync is Licensed under the terms of the 
// Microsoft Reciprocal License (Ms-RL)
//-----------------------------------------------------------------------------------------------------------
using System;
using WBFSe3.Formats;
using WBFSe3.IO;
using WbfsSync.Dialogs;

namespace WbfsSync.Core.Operations
{
    //-------------------------------------------------------------------------------------------------------
    //
    //-------------------------------------------------------------------------------------------------------
    public class FileOperation : Operation
    {
        //---------------------------------------------------------------------------------------------------
        //
        //---------------------------------------------------------------------------------------------------
        public WbfsFileInfo[] Source;
        public String Destination;
        public WbfsFormat Format;
        public DialogCopyFiles Dialog;


        //---------------------------------------------------------------------------------------------------
        //
        //---------------------------------------------------------------------------------------------------
        public FileOperation(String name, OperationType type, WbfsFileInfo[] files,
            String destination, WbfsFormat format)
            : base(name, type)
        {
            this.Format = format;
            this.Destination = destination;
            this.Source = new WbfsFileInfo[files.Length];
            files.CopyTo(this.Source, 0);
        }
    }
}
