﻿//-----------------------------------------------------------------------------------------------------------
// WBFSSync Project by Omega Frost 
// http://wbfssync.codeplex.com/
//
// WBFSSync is Licensed under the terms of the 
// Microsoft Reciprocal License (Ms-RL)
//-----------------------------------------------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WBFSe3.Formats
{
    //-------------------------------------------------------------------------------------------------------
    //
    //-------------------------------------------------------------------------------------------------------
    public abstract class WbfsFormat
    {
        //---------------------------------------------------------------------------------------------------
        //
        //---------------------------------------------------------------------------------------------------
        public abstract String Name { get; }
        public abstract int Version { get; }

        public abstract String Extension { get; }
        public abstract String Filter { get; }

        public abstract String Dev { get; }
        public abstract String Url { get; }

        public abstract int MaxSplitSize { get; }
        public abstract int MaxSplitFiles { get; }

        public abstract bool FixedSectorSize { get; }
        public abstract int DefaultSectorSize { get; }

        public abstract bool ReadOnlyFormat { get; }

        public abstract WbfsFormatReader InvokeReader();
        public abstract WbfsFormatCreator InvokeCreator();
    }
}
