﻿//-----------------------------------------------------------------------------------------------------------
// WBFSSync Project by Omega Frost 
// http://wbfssync.codeplex.com/
//
// WBFSSync is Licensed under the terms of the 
// Microsoft Reciprocal License (Ms-RL)
//-----------------------------------------------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WBFSe3.Wbfs;

namespace WBFSe3.Formats
{
    //-------------------------------------------------------------------------------------------------------
    //
    //-------------------------------------------------------------------------------------------------------
    public class WbfsIsoFormat : WbfsFormat
    {
        public override string Name { get { return "Disc image"; } }
        public override int Version { get { return 1; } }
        
        public override string Extension { get { return ".iso"; } }
        public override string Filter { get { return "*.iso"; } }

        public override string Dev { get { return "Omega Frost"; } }
        public override string Url { get { return "http://wbfssync.codeplex.com"; } }

        public override int MaxSplitSize { get { return 0; } }
        public override int MaxSplitFiles { get { return 0; } }

        public override bool FixedSectorSize { get { return false; } }
        public override int DefaultSectorSize { get { return WbfsConstants.WiiSectorSize; } }

        public override bool ReadOnlyFormat { get { return false; } }

        public override WbfsFormatReader InvokeReader() { return new WbfsIsoReader(); }
        public override WbfsFormatCreator InvokeCreator() { return new WbfsIsoCreator(); }
    }
}
